/*
  This code was written by Raymond Chi-Wing Wong.
  Please read the following.

    Raymond Chi-Wing Wong, Yufei Tao, Ada Wai-Chee Fu and Xiaokui Xiao. 
    "On Efficient Spatial Matching", 
    the 33rd International Conference on Very Large Data Bases (VLDB'07), 
    Vienna, Austria on 23-28 Sept, 2007 

*/

#ifndef STABLE_H
#define STABLE_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "point.h"
#include "assignment.h"
#include "set.h"
#include "rtree.h"

R_TYPE stable_distance(int indexO, int indexP, pointList *O, pointList *P, int noOfDim);

void stable_constructTwoPreferenceList(twoData *aTwoData, int ***preferenceListO, int ***preferenceListP, int noOfDim);
int **stable_constructOneRankList(int **preferenceListP, int noOfPointP, int noOfPointO);

assignment *stable_GaleShapley(twoData *orgTwoData, int noOfDim, int **preferenceO, int **rankP);

#endif
